SystemOrganization addCategory: #PasswordSpring!

Object subclass: #PasswordSpring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PasswordSpring'!

!PasswordSpring class methodsFor: 'service' stamp: 'HwaJong 11/21/2013 18:27'!
alphaNumeric: anInteger 
	^self
		characters: '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz' 
		length: anInteger! !

!PasswordSpring class methodsFor: 'service' stamp: 'HwaJong 11/21/2013 18:28'!
arbitrary: anInteger 
	^self
		characters: '!!"#$%&()*+,./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~' 
		length: anInteger! !

!PasswordSpring class methodsFor: 'private' stamp: 'HwaJong 11/21/2013 16:35'!
characters: aString length: anInteger
	^String streamContents: [ :stream| anInteger timesRepeat: [stream nextPut: aString atRandom] ]! !

!PasswordSpring class methodsFor: 'service' stamp: 'HwaJong 11/21/2013 18:28'!
numeric: anInteger 
	^self
		characters: '0123456789012345678901234567890123456789' 
		length: anInteger! !

!PasswordSpring class methodsFor: 'service' stamp: 'HwaJong 11/21/2013 18:25'!
pronouncableWord: anInteger 
	| vowels consonants enough |
	vowels := { 'a'. 'e'. 'i'. 'o'. 'u'. 'oa'. 'ee'. 'ie'. 'ea'. 'oo'. 'ou'. 'ia'. 'ai'. 'eo' }.
	consonants := { 'b'. 'c'. 'd'. 'f'. 'g'. 'h'. 'j'. 'k'. 'l'. 'm'. 'n'. 'p'. 'q'. 'r'. 's'. 't'. 'v'. 'w'. 'x'. 'y'. 'z'. 'ch'. 'sh'. 'th'. 'pr'. 'tr'. 'br'. 'cr'. 'fr'. 'st'. 'rm'. 'sk'. 'tt'. 'pp'. 'bl'. 'gr'. 'll'. 'ad'. 'add'}.
	enough := String streamContents: [ :stream| 
		[stream size < anInteger]
			whileTrue:
				[stream nextPutAll: consonants atRandom.
				stream nextPutAll: vowels atRandom]].
	^enough first: anInteger! !
